package ij.plugin;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2011</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
import ij.*;
import ij.gui.*;
import ij.util.Tools;
import java.awt.*;
import java.util.Vector;
import javax.swing.JCheckBox;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;
import javax.swing.JComboBox;

/** This plugin implements theImage/Overlay/Labels command. */
public class OverlayLabels implements PlugIn, DialogListener {
        private static final String[] fontSizes = {"7", "8", "9", "10", "12", "14", "18", "24", "28", "36", "48", "72"};
        private static Overlay defaultOverlay = new Overlay();
        private ImagePlus imp;
        private Overlay overlay;
        private GenericDialog gd;
        private static boolean showLabels;
        private static boolean showNames;
        private static boolean drawBackgrounds;
        private static String colorName;
        private static int fontSize;
        private static boolean bold;
        private Vector comboBox, checkBox;

        public void run(String arg) {
                imp = WindowManager.getCurrentImage();
                overlay = imp!=null?imp.getOverlay():null;
                if (overlay==null)
                        overlay = defaultOverlay;
                showDialog();
                if (!gd.wasCanceled()) {
                        defaultOverlay.drawLabels(overlay.getDrawLabels());
                        defaultOverlay.drawNames(overlay.getDrawNames());
                        defaultOverlay.drawBackgrounds(overlay.getDrawBackgrounds());
                        defaultOverlay.setLabelColor(overlay.getLabelColor());
                        defaultOverlay.setLabelFont(overlay.getLabelFont());
                }
        }

        public void showDialog() {
                showLabels = overlay.getDrawLabels();
                showNames = overlay.getDrawNames();
                drawBackgrounds = overlay.getDrawBackgrounds();
                colorName = Colors.getColorName(overlay.getLabelColor(), "white");
                fontSize = 12;
                Font font = overlay.getLabelFont();
                if (font!=null) {
                        fontSize = font.getSize();
                        bold = font.getStyle()==Font.BOLD;
                }
                gd = new GenericDialog("Labels");
                gd.addChoice("Color:", Colors.colors, colorName);
                gd.addChoice("Font size:", fontSizes, ""+fontSize);
                comboBox = gd.getChoices();
                for(int i=0; i < comboBox.size(); i++){
                    thisChoice[i] = (JComboBox)comboBox.elementAt(i);// JCheckBox();
                    thisChoice[i].addItemListener(itemListener);
                }
                gd.addCheckbox("Show labels", showLabels);
                gd.addCheckbox("Use names as labels", showNames);
                gd.addCheckbox("Draw backgrounds", drawBackgrounds);
                gd.addCheckbox("Bold", bold);
                checkBox = gd.getCheckboxes();
                for(int i=0; i < checkBox.size(); i++){
                    cb[i] = (JCheckBox)checkBox.elementAt(i);// JCheckBox();
                    cb[i].addItemListener(itemListener);
                }
                gd.addDialogListener(this);
                gd.showDialog();
        }

       JComboBox[] thisChoice = new JComboBox[2];
       JCheckBox[] cb = new JCheckBox[4];

        public boolean dialogItemChanged(GenericDialog gd, AWTEvent e) {
                return true;
        }

        public static Overlay createOverlay() {
                return defaultOverlay.duplicate();
        }
        ItemListener itemListener = new ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                Object obj = e.getSource();
                if(obj instanceof JCheckBox){
                }
                if(obj instanceof JComboBox){
                }
                if (gd.wasCanceled()) return ;
                String colorName2 = colorName;
                boolean showLabels2 = showLabels;
                boolean showNames2 = showNames;
                boolean drawBackgrounds2 = drawBackgrounds;
                boolean bold2 = bold;
                int fontSize2 = fontSize;
                colorName = (String)((JComboBox)comboBox.elementAt(0)).getSelectedItem();
                fontSize = (int)Tools.parseDouble(
                                        (String)((JComboBox)comboBox.elementAt(1)).getSelectedItem(), 12);
                showLabels = ((JCheckBox)checkBox.elementAt(0)).isSelected();
                showNames = ((JCheckBox)checkBox.elementAt(1)).isSelected();
                drawBackgrounds = ((JCheckBox)checkBox.elementAt(2)).isSelected();
                bold = ((JCheckBox)checkBox.elementAt(3)).isSelected();
                boolean colorChanged = !colorName.equals(colorName2);
                boolean sizeChanged = fontSize!=fontSize2;
                boolean changes = showLabels!=showLabels2 || showNames!=showNames2
                        || drawBackgrounds!=drawBackgrounds2 || colorChanged || sizeChanged
                        || bold!=bold2;
                if (changes) {
                        if (showNames || colorChanged || sizeChanged) {
                                showLabels = true;
                                ((JCheckBox)checkBox.elementAt(0)).setSelected(true);
                        }
                        overlay.drawLabels(showLabels);
                        overlay.drawNames(showNames);
                        overlay.drawBackgrounds(drawBackgrounds);
                        Color color = Colors.getColor(colorName, Color.white);
                        overlay.setLabelColor(color);
                        if (sizeChanged || bold || bold!=bold2)
                                overlay.setLabelFont(new Font("SansSerif", bold?Font.BOLD:Font.PLAIN, fontSize));
                        if (imp!=null && imp.getOverlay()!=null)
                                imp.draw();
                }
            }
        };
        }
