package ij2x.plugin;

import java.awt.Color;
import java.awt.event.MouseEvent;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.Image;

import java.util.Locale;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

import javax.swing.BorderFactory;
import javax.swing.border.Border;
import javax.swing.ImageIcon;
import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.border.BevelBorder;

import ij.IJ;
import ij.ImageJ;
import ij.ImagePlus;
import ij.ImageStack;
import ij.plugin.PlugIn;

import ij2x.util.ResourceString;
import ij2x.util.BorderlessButton;
import ij2x.util.AWTImages;
import ij2x.util.ImageIcons;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2012</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class StackControlPanel extends JPanel implements PlugIn, MouseListener, MouseMotionListener, ActionListener{
    private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
    private Border lightGrayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.lightGray,Color.lightGray );
    private long mouseDownTime;
    public boolean startStop = true, flipflop=false;
    public static final int DOUBLE_CLICK_THRESHOLD = 50;
    private boolean pressed;
    public JPanel buttons;
    protected ImageJ ij;
    private ImagePlus imp;
    private ImageStack stack;
    public JPanel controlPanel=new JPanel();
    public JButton draggedButton, closeButton, undecoratedButton, action;
    public JButton tobeginnButton, revButton,
                        stopButton, fwdButton, toendButton
                                , addSliceButton, removeSliceButton, addStackButton, makeStackButton
                        , insertSlicesButton, removeSlicesButton, buildStackButton, splitStackButton
                        , stackButton, spliterButton, reversButton, to3dButton, montageButton;


                private static ResourceBundle resources;
                private int index = 0;

                static {
                    try {
                        resources = ResourceBundle.getBundle("ij2x.plugin.resources.StackBar",
                                                             Locale.getDefault());
                    } catch (MissingResourceException mre) {
                        System.err.println("resources/StackBar.properties not found");
                        System.exit(1);
                    }
                }

    public StackControlPanel(){
        ij = IJ.getInstance();
    }

    public void run(String arg){
        ij = IJ.getInstance();
        controlPanel=controlButton();
    }

    public JPanel controlButton() {
        buttons = new JPanel();
        buttons.setBorder(lightGrayBorder);
        FlowLayout buttonsFlowLayout = new FlowLayout(FlowLayout.LEFT, 0, 0);
        buttons.setLayout(buttonsFlowLayout);

        ImageIcon b1o = ImageIcons.getIcons(this);

        AWTImages.setImageDir("stackDir");


    String[] iconAllName = ResourceString.tokenize(ResourceString.getResourceString(resources, "stackbar"));

    Image[][] icons = new Image[iconAllName.length][3];
    for(int i=0; i < iconAllName.length; i++){
        for(int j=0; j < 3; j++){
            icons[i][j]=((ImageIcon)AWTImages.createBufferedIcon(
                    this
                      , ResourceString.tokenize(ResourceString.getResourceString(resources, iconAllName[i]))[j]
                        , b1o.getImage()
                          , 24)).getImage();
        }
    }

    addSliceButton=BorderlessButton.createButton(this, addSliceButton, "Add Slice", icons[index++]);
    removeSliceButton=BorderlessButton.createButton(this, removeSliceButton, "Remove Slice", icons[index++]);
    insertSlicesButton=BorderlessButton.createButton(this, insertSlicesButton, "Stack Inserter", icons[index++]);
    removeSlicesButton=BorderlessButton.createButton(this, removeSlicesButton, "Slices Remover ", icons[index++]);
    addStackButton=BorderlessButton.createButton(this, addStackButton, "Concatenated Stacks", icons[index++]);
    makeStackButton=BorderlessButton.createButton(this, makeStackButton, "Stack Maker", icons[index++]);
    stackButton=BorderlessButton.createButton(this, stackButton, "Stack Builder", icons[index++]);
    spliterButton=BorderlessButton.createButton(this, spliterButton, "Stack Spliter", icons[index++]);
    reversButton=BorderlessButton.createButton(this, reversButton, "Stack Reverser", icons[index++]);
    to3dButton=BorderlessButton.createButton(this, to3dButton, "Stack to 3D", icons[index++]);
    montageButton=BorderlessButton.createButton(this, montageButton, "Stack to Montage", icons[index++]);

        buttons.add(addSliceButton);
        buttons.add(removeSliceButton);

        buttons.add(stackButton);
        buttons.add(montageButton);
        buttons.add(reversButton);
        buttons.add(to3dButton);
        buttons.add(spliterButton);
        buttons.add(addStackButton);
        buttons.add(makeStackButton);
        buttons.add(insertSlicesButton);
        buttons.add(removeSlicesButton);
        return buttons;
    }


    void toBeginn() throws Exception{
        IJ.runPlugIn("ij.plugin.Animator", "beginn");
    }
    void toEnd() throws Exception{
        IJ.runPlugIn("ij.plugin.Animator", "end");
    }
    void previous() throws Exception{
        IJ.runPlugIn("ij.plugin.Animator", "previous");
    }
    void next() throws Exception{
        IJ.runPlugIn("ij.plugin.Animator", "next");
    }
    void delSlice() throws Exception{
        IJ.runPlugIn("ij.plugin.StackEditor", "delete");
    }
    void insertSlice() throws Exception{
        IJ.runPlugIn("ij.plugin.StackEditor", "add");
    }
    void delSlices() throws Exception{
        IJ.runPlugIn("ij.plugin.SliceRemover", "");
    }
    void insertSlices() throws Exception{
        IJ.runPlugIn("ij2x.plugin.StackInserter", "");
    }
    void buildStack() throws Exception{
        IJ.runPlugIn("ij.plugin.ImagesToStack", "");
    }
    void splitStack() throws Exception{
        IJ.runPlugIn("ij.plugin.StackEditor", "toimages");
    }
    void addStack() throws Exception{
        IJ.runPlugIn("ij2x.plugin.Concatenator", "");
    }
    void reversStack() throws Exception{
        IJ.runPlugIn("ij2x.plugin.StackReverser", "");
    }
    void makeStack() throws Exception{
        IJ.runPlugIn("ij2x.plugin.StackMaker", "");
   }
   void make3D() throws Exception{
       IJ.runPlugIn("ij.plugin.Projector", "");
  }
  void makeMontage() throws Exception{
      IJ.runPlugIn("ij.plugin.MontageMaker", "");
 }

    public void mousePressed(MouseEvent e) {
         action = (JButton)e.getSource();
        int x = e.getX();
        float rate=0;
        boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
        mouseDownTime = System.currentTimeMillis();
             if (!doubleClick) {
             }
             pressed=true;
     }

     public void mouseReleased(MouseEvent e) {
       action = (JButton)e.getSource();
       int x = e.getX();
       float rate=0;
       boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
       mouseDownTime = System.currentTimeMillis();
            if (pressed) {
            }
            pressed=false;
     }
    public void mouseExited(MouseEvent e) {}
    public void mouseClicked(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseDragged(MouseEvent e) {}
    public void mouseMoved(MouseEvent e) {
        JButton action = (JButton) e.getSource();
        int x = e.getX();
        boolean doubleClick = (System.currentTimeMillis() - mouseDownTime) <=
                              DOUBLE_CLICK_THRESHOLD;
        mouseDownTime = System.currentTimeMillis();
        if (!false) {
            if (action == tobeginnButton) {
                IJ.showStatus("Beginn Slice");
            } else if (action == fwdButton) {
                IJ.showStatus("Next Slice");
            } else if (action == addSliceButton) {
                IJ.showStatus("Add Slice");
            } else if (action == removeSliceButton) {
                IJ.showStatus("Remove Slice");
            } else if (action == insertSlicesButton) {
                IJ.showStatus("Insert Slices");
            } else if (action == addStackButton) {
                IJ.showStatus("Image to Stack");
            } else if (action == makeStackButton) {
                IJ.showStatus("Make Stack");
            } else if (action == revButton) {
                IJ.showStatus("Previous Slice");
            } else if (action == toendButton) {
                IJ.showStatus("End Slice");
            }else if (action == draggedButton) {
                IJ.showStatus("Move...");
            } else if (action == closeButton) {
                IJ.showStatus("Decorated Frame");
            } else if (action == undecoratedButton) {
                IJ.showStatus("Undecorated Frame");
            }
            else if (action == montageButton){
                IJ.showStatus("Make Montage...");
            }
            else if (action == to3dButton){
                IJ.showStatus("3D Project...");
            }

        }
    }
    // Action listener method
    public void actionPerformed(ActionEvent e){
        try {
            if (action == tobeginnButton){
                toBeginn();
            }
              else if (action == revButton){
                  previous();
             }
              else if (action == fwdButton){
                  next();
              }
              else if (action == toendButton){
                  toEnd();
              }
              if (action == addSliceButton){
                  insertSlice();
              }
                else if (action == removeSliceButton){
                    delSlice();
               }
               else if (action == insertSlicesButton){
                   insertSlices();
               }
               else if (action == removeSlicesButton){
                   delSlices();
               }
               else if (action == stackButton){
                   buildStack();
               }
               else if (action == spliterButton){
                   splitStack();
               }
               else if (action == addStackButton){
                   addStack();
               }
               else if (action == reversButton){
                   reversStack();
               }
               else if (action == makeStackButton){
                   makeStack();
               }
               else if (action == montageButton){
                   makeMontage();
               }
               else if (action == to3dButton){
                   make3D();
               }
        }
         catch (Exception ex) {
        ex.printStackTrace();
    }

    }

}
